#pragma once

#include <vector>
#include <ostream>

#include <glm/vec3.hpp>
#include <glm/vec4.hpp>

typedef std::vector<glm::vec3> vec3v_t;
typedef std::vector<glm::vec2> vec2v_t;
typedef std::vector<glm::uvec3> uvec3v_t;
typedef std::vector<glm::uvec4> uvec4v_t;

void calculateNormals(const vec3v_t &vtx, uvec3v_t &tri, vec3v_t &normals);
void findEdges(const vec3v_t &vtx, uvec3v_t &tri, uvec4v_t &edges);

void moveToMean(vec3v_t &vtx);

void smooth(vec3v_t &vtx, const uvec3v_t &tri);

void saveAttrib(std::ostream &out, const char *prefix, vec3v_t &elements);

void saveAttrib(std::ostream &out, const char *prefix, vec2v_t &elements);

void saveFaces(std::ostream &out, const uvec3v_t &tris, size_t attribs);

void computeTangentBasis(vec3v_t & vertices, vec2v_t & uvs, vec3v_t & normals,
		vec3v_t & tangents, vec3v_t & bitangents);
